<%-- $Id: select_installation_type.jsp 4940 2009-05-20 06:42:43Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------


	@author Martin
	@version 2.5
--%>

<%@ page session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"	
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final Item itemType = Item.PLUGINDEFINITION;
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final DbControl dc = sc.newDbControl();

String title = "Installation type";
java.io.File pluginDir = Application.getNonCorePluginDirectory();
boolean pluginDirEnabled = pluginDir != null && pluginDir.exists();

java.io.File extensionsDir = new java.io.File(application.getRealPath(ExtensionsControl.EXTENSIONS_URL));
boolean extensionsDirEnabled = extensionsDir != null && extensionsDir.exists();

try
{
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head>
		<script language="JavaScript">
		
			var lastSelectedType;
			function typeOnChange()
			{
				var frm = document.forms['installations'];
				var types = frm.installationType;
				var type = types[types.selectedIndex].value;		
				
				if (lastSelectedType)
				{
					Main.hide('description.'+lastSelectedType)
				}				
				Main.show('description.'+type);
				if (type == 'auto')
				{
					Main.show('directories');
				}
				else
				{
					Main.hide('directories');
				}
				lastSelectedType = type;
			}
			function doNext()
			{
				var frm = document.forms['installations'];
				var types = frm.installationType;
				var type = types[types.selectedIndex].value;		
				if (type == 'auto')
				{
					if (!frm['plugindir'].checked && !frm['extensionsdir'].checked)
					{
						alert('Please select at least one directory for automatic installation');
						return;
					}
				}
				frm.submit();
			}			
			function init()
			{
				typeOnChange();
			}
		</script>
	</base:head>
	<base:body onload="init()">
		<form name="installations" action="index.jsp" method="post" onsubmit="return false;">
		<input type="hidden" name="ID" value="<%=ID%>">
		<input type="hidden" name="cmd" value="InstallationType">
	
		<h3 class="docked"><%=title%> <base:help helpid="plugindefinition.installationtype" /></h3>
		<div class="boxed">
			<div class="helpmessage">
				Select how to install the plugin(s).
			</div>
			
			<table class="form" width="100%">
			<tr valign="top">
				<td class="prompt" width="100px">Install</td>
				<td>
					<select name="installationType" class="required" onchange="typeOnChange()">
						<option value="auto">Automatically</option>
						<option value="manual">Manually</option>
					</select>
				</td>
			</tr>
			<tr id=directories valign="top" style="display:none;">
				<td class="prompt">Directories</td>
				<td>
					<input type="checkbox" name="plugindir" checked value="1" 
						<%=pluginDirEnabled ? "" : "disabled" %>
						>Dedicated plug-ins directory (<%=pluginDir%>)<br>
					<input type="checkbox" name="extensionsdir" checked value="1"
						<%=extensionsDirEnabled ? "" : "disabled" %>
						>Extensions directory (<%=extensionsDir%>)
				</td>
			</tr>				
			</table>
			
			<div id="descriptions" class="helpmessage">
				<div id="description.auto" style="display:none;">
					<b>Automatically install non-core plugins</b><br>
					The selected paths above will be scanned for plugins in jar-files.<br>
					Plugins that were found will be available for selection in the next step.
				</div>
				<div id="description.manual" style="display:none;">
					<b>Manually install plugins</b><br>
					The plugin´s class name and jar path have to be defined manually.
				</div>
			</div>
		</div>
		</form>
		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="doNext();" title="Next" /></td>
			<td width="50%"><base:button onclick="window.close();" title="Cancel" /></td>
		</tr>
		</table>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
 %>
 