<%-- $Id: manage.jsp 4889 2009-04-06 12:52:39Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Johan Enell
	Copyright (C) 2006 Jari Hkkinen

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.clients.web.util.HTML"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final Item itemType = Item.valueOf(request.getParameter("item_type"));
final String subContext = request.getParameter("subcontext");
final ItemContext current = sc.getCurrentContext(itemType, subContext);
final Enumeration<Integer, String> contextNames = sc.getContextNames(itemType, subContext);
int numListed = 0;
%>
<base:page type="popup" title="Manage presets">
<base:head scripts="table.js" styles="table.css">
	<script language="JavaScript">
	function loadContext(contextId)
	{
		location.href = 'index.jsp?ID=<%=ID%>&cmd=LoadContext&item_type=<%=itemType.name()%>&subcontext=<%=subContext%>&context_id='+contextId;
	}
	function deleteContext(contextId)
	{
		if (confirm('This action can\'t be undone. Continue?'))
		{
			location.href = 'index.jsp?ID=<%=ID%>&cmd=DeleteContext&context_id='+contextId;
		}
	}
	function deleteContexts()
	{
		var frm = document.forms['contexts'];
		var numChecked = Forms.numChecked(frm);
		if (numChecked == 0)
		{
			alert('Please select at least one item in the list');
			return; 
		}
		else
		{
			var rep = numChecked == 1 ? 'context' : 'contexts';
			if (!confirm('You are about to delete '+numChecked+' '+rep+'. This can\'t be undone. Continue?'))
			{
				return;
			}
		}
		frm.cmd.value = 'DeleteContexts';
		frm.submit();
	}
	</script>
</base:head>
<base:body>
	<p>

	<%
	if (contextNames.size() == 0)
	{
		%>
		<base:note type="info" title="No presets found" >
		You have not saved any presets for 
		<%=itemType%> <%="".equals(subContext) ? "" : "(" + subContext + ")" %>
		</base:note>
		<%
	}
	else
	{
		%>
		<h3 class="docked">Manage presets for <%=itemType%> <%="".equals(subContext) ? "" : "(" + subContext + ")" %>
			<base:help helpid="contexts.manage" /></h3>
			<tbl:table 
				id="contexts"
				clazz="itemlist"
				action="index.jsp"
				>
				<tbl:hidden
					name="item_type"
					value="<%=itemType.name()%>"
				/>
				<tbl:hidden
					name="subcontext"
					value="<%=subContext%>"
				/>
				<tbl:columndef
					id="name"
					title="Name"
				/>
				<tbl:columndef
					id="actions"
					title="&nbsp;"
				/>
				<tbl:toolbar
					visible="true"
					>
					<tbl:button 
						image="delete.gif" 
						onclick="deleteContexts()" 
						title="Delete&hellip;" 
						tooltip="Delete the selected items" 
					/>
				</tbl:toolbar>
				<tbl:data>
					<tbl:columns>
						<tbl:header 
							clazz="index"
							style="border-right: 1px solid #999999"
							>&nbsp;</tbl:header>
						<tbl:header 
							clazz="check"
							style="border-right: 1px solid #999999"
							visible="true"
							><base:icon 
								image="check_uncheck.gif" 
								tooltip="Check/uncheck all" 
								onclick="Forms.checkUncheck(document.forms['contexts'])" style="align: left;"
							/></tbl:header>
					</tbl:columns>
					<tbl:rows>
					<%
					for (int i = 0; i < contextNames.size(); ++i)
					{
						String name = contextNames.getValue(i);
						int id = contextNames.getKey(i);
						if (!ItemContext.DEFAULT_NAME.equals(name))
						{
							numListed++;
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									style="border-right: 1px solid #999999"
									><%=numListed%></tbl:header>
								<tbl:header 
									clazz="check"
									style="border-right: 1px solid #999999"
									visible="true"
									><input 
										type="checkbox" 
										name="<%=id%>" 
										value="<%=id%>" 
										title="<%=HTML.encodeTags(name)%>" 
									></tbl:header>
								<tbl:cell column="name"><%=HTML.encodeTags(name)%></tbl:cell>
								<tbl:cell column="actions">
									<a href="javascript:loadContext(<%=id%>)" title="Load this preset">Load</a>
								</tbl:cell>
							</tbl:row>
						<%
						}
					}
					%>
					</tbl:rows>
				</tbl:data>
				<%
				if (numListed == 0)
				{
					%>
					<tbl:panel>No presets were found</tbl:panel>
					<%
				}
				%>
			</tbl:table>
			<br>
			<%
		}
		%>

	<table align="center">
	<tr>
		<td><base:button onclick="window.close();" title="Close" /></td>
	</tr>
	</table>

</base:body>
</base:page>
