<%-- $Id: view_file.jsp 5065 2009-08-19 12:42:25Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.Application"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Group"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.File"
	import="net.sf.basedb.core.FileType"
	import="net.sf.basedb.core.Location"
	import="net.sf.basedb.core.MultiPermissions"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ChangeHistoryUtil"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.Collections"
	import="java.util.Date"
	import="java.util.Map"
	import="java.util.Set"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.FILE;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.ITEM);
%>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);
final int itemId = cc.getId();
final float scale = Base.getScale(sc);
final String tab = Values.getString(request.getParameter("tab"), "properties");
final DbControl dc = sc.newDbControl();
try
{
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);

	String title = null;
	File file = File.getById(dc, itemId);
	String path = file.getPath().toString();
	String urlPath = HTML.urlEncode(path);
	String bytes = Values.formatBytes(file.getSize(), 2);
	
	final boolean writePermission = file.hasPermission(Permission.WRITE);
	final boolean deletePermission = file.hasPermission(Permission.DELETE);
	final boolean sharePermission = file.hasPermission(Permission.SET_PERMISSION);
	final boolean setOwnerPermission = file.hasPermission(Permission.SET_OWNER);
	final boolean isRemoved = file.isRemoved();
	final boolean isUsed = isRemoved && file.isUsed();
	final boolean deletePermanentlyPermission = deletePermission && !isUsed;
	final boolean isOwner = file.isOwner();
	final String mimeType = file.getMimeType();
	final boolean editable = writePermission && !file.isWriteProtected() &&
		mimeType != null &&  mimeType.startsWith("text/") && 
		file.getSize() < 102400 && file.getLocation() == Location.PRIMARY;

	Formatter<Date> dateTimeFormatter = FormatterFactory.getDateTimeFormatter(sc);
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, guiContext, file);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	%>
	<base:page type="popup" title="<%=title%>">
	<base:head scripts="table.js,tabcontrol.js" styles="table.css,toolbar.css,headertabcontrol.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		function editItem()
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>, true);
		}
		function shareItem()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=ShareItem&item_id=<%=itemId%>', 'ShareFile', 600, 400);
		}
		function deleteItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=DeleteItem&item_id=<%=itemId%>');
		}
		function restoreItem()
		{
			location.replace('index.jsp?ID=<%=ID%>&cmd=RestoreItem&item_id=<%=itemId%>');
		}
		function deleteItemPermanently()
		{
			Main.deleteItemPermanently('<%=ID%>', true, '<%=itemType.name()%>', <%=itemId%>, '&callback=itemDeleted');
		}
		function itemDeleted()
		{
			location.replace(getRoot() + 'filemanager/files/index.jsp?ID=<%=ID%>');
		}
		function showUsingItems()
		{
			Main.showUsingItems('<%=ID%>', '<%=itemType.name()%>', <%=itemId%>);
		}
		function setOwner()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=SetOwnerOfItem&item_id=<%=itemId%>', 'SetOwnerOfItem', 450, 150);
		}
		function runPlugin(cmd)
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd='+cmd+'&item_id=<%=itemId%>', 'RunPlugin'+cmd, 740, 540);
		}
		function uploadFile()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=UploadFile&item_id=<%=itemId%>', 'UploadFile', 680, 520);
		}
		function moveOffline()
		{
			var msg = "This action will remove the file data of the selected file from the server.\n";
			msg += "If you need the data again you have to re-upload the file.\n\n";
			msg += "Continue?";
			if (!confirm(msg)) return;	
			location.href = "index.jsp?ID=<%=ID%>&cmd=MoveItem&move=0&item_id=<%=itemId%>";
		}
		function compress()
		{
			Main.openPopup('../../common/progress_reporter.jsp?ID=<%=ID%>&progress=compress&title=Compressing file', 'CompressFile', 400, 200);
			location.replace('index.jsp?ID=<%=ID%>&cmd=CompressItem&item_id=<%=itemId%>');
		}
		function decompress()
		{
			Main.openPopup('../../common/progress_reporter.jsp?ID=<%=ID%>&progress=decompress&title=Decompressing file', 'UncompressFile', 400, 200);
			location.replace('index.jsp?ID=<%=ID%>&cmd=DecompressItem&item_id=<%=itemId%>');
		}
		function editFileData()
		{
			Main.openPopup('index.jsp?ID=<%=ID%>&cmd=EditFileData&item_id=<%=itemId%>', 'EditFileData', 900, 700);
		}
		function switchTab(tabControlId, tabId)
		{
			if (TabControl.isActive(tabControlId, tabId)) return;
			if (tabId == 'history' && tabId != '<%=tab%>')
			{
				location.href = 'index.jsp?ID=<%=ID%>&cmd=ViewItem&item_id=<%=itemId%>&tab='+tabId;
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		</script>
	</base:head>
	<base:body>
		<t:tabcontrol id="main" active="<%=tab%>" switch="switchTab" remember="false">
		<t:tab id="properties" title="Properties">
		<tbl:toolbar
			>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "edit.gif" : "edit_disabled.gif"%>" 
				onclick="editItem()" 
				title="Edit&hellip;" 
				tooltip="<%=writePermission ? "Edit this file" : "You do not have permission to edit this file"%>" 
			/>
			<tbl:button 
				visible="<%=editable%>"
				image="file_edit.png" 
				onclick="editFileData()" 
				title="Edit file&hellip;" 
				tooltip="Edit the contents of this file" 
			/>
			<tbl:button 
				disabled="<%=deletePermission ? false : true%>" 
				image="<%=deletePermission ? "delete.gif" : "delete_disabled.gif"%>" 
				onclick="deleteItem()" 
				title="Delete"
				visible="<%=!file.isRemoved()%>"
				tooltip="<%=deletePermission ? "Delete this file" : "You do not have permission to delete this file"%>" 
			/>
			<tbl:button 
				disabled="<%=writePermission ? false : true%>" 
				image="<%=writePermission ? "restore.gif" : "restore_disabled.gif"%>" 
				onclick="restoreItem()" 
				title="Restore"
				visible="<%=file.isRemoved()%>"
				tooltip="<%=writePermission ? "Restore this file" : "You do not have permission to restore this file"%>" 
			/>
			<tbl:button 
				disabled="<%=sharePermission ? false : true%>"
				image="<%=sharePermission ? "share.gif" : "share_disabled.gif"%>"
				onclick="shareItem()" 
				title="Share&hellip;" 
				tooltip="<%=sharePermission ? "Share this file to other user, groups and projects" : "You do not have permission to share this file"%>"
			/>
			<tbl:button 
				disabled="<%=setOwnerPermission ? false : true%>"
				image="<%=setOwnerPermission ? "take_ownership.png" : "take_ownership_disabled.png"%>"
				onclick="setOwner()" 
				title="Set owner&hellip;"
				tooltip="<%=setOwnerPermission ? "Change owner of this item" : "You do not have permission to change ownership of this item"%>"
			/>
			<tbl:button
				disabled="<%=!writePermission%>"
				image="<%=writePermission ? "compress.png" : "compress_disabled.png"%>"
				onclick="compress()"
				title="Compress&hellip;"
				visible="<%=!file.isCompressed()%>"
				tooltip="Store this file in a compressed format on the disk"
			/>
			<tbl:button
				disabled="<%=!writePermission%>"
				image="<%=writePermission ? "decompress.png" : "decompress_disabled.png"%>"
				onclick="decompress()"
				title="Decompress&hellip;"
				visible="<%=file.isCompressed()%>"
				tooltip="Decompress this file and store it in it's normal format on the disk"
			/>
			<tbl:button 
				image="import.gif" 
				onclick="runPlugin('ImportItem')" 
				title="Import&hellip;" 
				tooltip="Import data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
			/>
			<tbl:button 
				image="export.gif" 
				onclick="runPlugin('ExportItem')" 
				title="Export&hellip;" 
				tooltip="Export data" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
			/>
			<tbl:button 
				image="runplugin.gif" 
				onclick="runPlugin('RunPlugin')" 
				title="Run plugin&hellip;" 
				tooltip="Run a plugin" 
				visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER)%>"
			/>
			<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
				wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
			<tbl:button
				image="help.gif"
				onclick="<%="Main.openHelp('" + ID +"', 'file.view.properties')"%>"
				title="Help&hellip;"
				tooltip="Get help about this page"
			/>
			</tbl:toolbar>
		<div class="boxedbottom">
			<div class="itemstatus">Permissions on this item: <i><%=PermissionUtil.getFullPermissionNames(file)%></i></div>
			<%
			if (file.isRemoved() || file.isShared())
			{
				%>
				<div class="itemstatus">
					<base:icon 
						image="<%=deletePermanentlyPermission ? "deleted.gif" : "deleted_disabled.gif"%>"
						onclick="<%=deletePermanentlyPermission ? "deleteItemPermanently()" : null%>"
						tooltip="<%=deletePermanentlyPermission ? "Permanently delete this item" : null%>"
						visible="<%=isRemoved%>"> This item has been flagged for deletion<br></base:icon>
					<base:icon image="used.gif" 
						onclick="showUsingItems()"
						tooltip="Show the items that are using this one"
						visible="<%=isUsed%>"> This item is used by other items and can't be permanently deleted<br></base:icon>
					<base:icon image="shared.gif" 
						visible="<%=file.isShared()%>"> This item is shared to other users, groups and/or projects</base:icon>
				</div>
				<%
			}
			%>
			<table class="form" cellspacing=0>
			<tr>
				<td class="prompt">File</td>
				<td><%=HTML.encodeTags(path)%></td>
			</tr>
			<tr>
				<td class="prompt">Write protected</td>
				<td><%=file.isWriteProtected() ? "yes" : "no"%></td>
			</tr>
			<tr>
				<td class="prompt">Type</td>
				<td><base:propertyvalue item="<%=file%>" property="fileType" /></td>
			</tr>
			<tr>
				<td class="prompt">MIME type</td>
				<td><%=HTML.encodeTags(file.getMimeType())%></td>
			</tr>
			<tr>
				<td class="prompt">Character set</td>
				<td><%=HTML.encodeTags(file.getCharacterSet() == null ? "n/a" : file.getCharacterSet())%></td>
			</tr>			
			<%
			File.Action action = file.getAction();
			Location location = file.getLocation();
			%>
			<tr valign="baseline">
				<td class="prompt">Location</td>
				<td><%=location%>
				<%
				if (action == File.Action.MOVE_TO_PRIMARY)
				{
					%>
					(Wating for move to primary)
					<%
				}
				else if (action == File.Action.MOVE_TO_SECONDARY)
				{
					%>
					(Wating for move to secondary)
					<%
				}
				%>
				<%
				if (location == Location.PRIMARY)
				{
					%>
					[<a href="javascript:Main.viewFile('<%=ID%>', <%=itemId%>)"><base:icon image="view.gif" tooltip="<%="View the contents of this file (" + bytes + ")"%>" /></a>
					<a href="javascript:Main.downloadFile('<%=ID%>', <%=itemId%>)"><base:icon image="download.gif" tooltip="<%="Download the contents of this file (" + bytes + ")"%>" /></a>
					<%
					if (file.hasPermission(Permission.WRITE) && !file.isWriteProtected())
					{
						%>
						| <a href="javascript:moveOffline()">move offline</a>
						<%
						if (action == File.Action.MOVE_TO_SECONDARY)
						{
							%>
							| <a href="index.jsp?ID=<%=ID%>&cmd=MoveItem&move=1&item_id=<%=itemId%>">cancel move to secondary
							<%
						}
						else if (Application.hasSecondaryStorage())
						{
							%>
							| <a href="index.jsp?ID=<%=ID%>&cmd=MoveItem&move=2&item_id=<%=itemId%>">move to secondary</a>
							<%
						}
						%>
						| <a href="javascript:uploadFile()">replace</a>
						<%
					}
					%>
					]
					<%
				}
				else if (location == Location.SECONDARY)
				{
					%>
					[<a href="javascript:moveOffline()">move offline</a>
					<%
					if (action == File.Action.MOVE_TO_PRIMARY)
					{
						%>
						| <a href="index.jsp?ID=<%=ID%>&cmd=MoveItem&move=2&item_id=<%=itemId%>">cancel move to primary
						<%
					}
					else
					{
						%>
						| <a href="index.jsp?ID=<%=ID%>&cmd=MoveItem&move=1&item_id=<%=itemId%>">move to primary</a>
						<%
					}
					%>
					]
					<%
				}
				else if (location == Location.OFFLINE)
				{
					%>
					[<a href="javascript:uploadFile()"><base:icon image="upload.gif" tooltip="Upload this file again" /></a>]
					<%
				}
				%>
				
				</td>
			</tr>
			<tr>
				<td class="prompt">Size</td>
				<td title="<%=file.getSize()%> bytes"><%=bytes%></td>
			</tr>
			<%
			if (file.isCompressed())
			{
				%>
				<tr>
					<td class="prompt">Compressed Size</td>
					<td title="<%=file.getCompressedSize()%> bytes"><%=Values.formatBytes(file.getCompressedSize())%></td>
				</tr>
				<%
			}
			%>
			<tr>
				<td class="prompt">Last update</td>
				<td><%=dateTimeFormatter.format(file.getLastUpdate())%></td>
			</tr>
			<tr>
				<td class="prompt">Owner</td>
				<td><base:propertyvalue item="<%=file%>" property="owner" /></td>
			</tr>
			<tr>
				<td class="prompt">MD5</td>
				<td><%=file.getMd5()%></td>
			</tr>
			<tr>
				<td class="prompt">Description</td>
				<td><%=HTML.niceFormat(file.getDescription())%></td>
			</tr>
			</table>
			<%			
			
			// Tables with users/groups/projects that this item is shared to
			MultiPermissions mp = new MultiPermissions(Collections.singleton(file));
			ItemResultList<User> users = mp.getUsers().list(dc);
			ItemResultList<Group> groups = mp.getGroups().list(dc);
			ItemResultList<Project> projects = mp.getProjects().list(dc);
			int totalShare = users.size() + groups.size() + projects.size();
			
			if (totalShare > 0)
			{
				%>
				<base:section
					id="sharedTo"
					title="<%="Shared to (" + totalShare + ")"%>"
					context="<%=cc%>"
					>
					<tbl:table 
						id="itemsSharedTo"
						clazz="itemlist"
						columns="all"
					>
						<tbl:columndef 
							id="itemType"
							title="Item type"
						/>
						<tbl:columndef 
							id="name"
							title="Name"
						/>
						<tbl:columndef 
							id="permissions"
							title="Permissions"
						/>
						<tbl:data>
							<tbl:columns>
							</tbl:columns>
							<tbl:rows>
							<%
							for (Project project : projects)								
							{
								Set<Permission> permissions = mp.getPermissions(project).values().iterator().next();
								%>			
								<tbl:row>
									<tbl:cell column="itemType"><%=project.getType()%></tbl:cell>
									<tbl:cell column="name"><base:icon 
										image="deleted.gif" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=project.isRemoved()%>"
									/><%=Base.getLinkedName(ID, project, false, true)%></tbl:cell>
									<tbl:cell column="permissions">
										<%=PermissionUtil.translatePermissionsToString(permissions)%>
									</tbl:cell>
								</tbl:row>
								<%
							}
							for (Group group : groups)
							{
								Set<Permission> permissions = mp.getPermissions(group).values().iterator().next();
								%>
								<tbl:row>							
									<tbl:cell column="itemType"><%=group.getType()%></tbl:cell>
									<tbl:cell column="name"><base:icon 
										image="deleted.gif" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=group.isRemoved()%>"
									/><%=Base.getLinkedName(ID, group, false, true)%></tbl:cell>
									<tbl:cell column="permissions">
										<%=PermissionUtil.translatePermissionsToString(permissions)%>
									</tbl:cell>
								</tbl:row>
								<%	
							}
							for (User user : users)
							{
								Set<Permission> permissions = mp.getPermissions(user).values().iterator().next();
								%>
								<tbl:row>							
									<tbl:cell column="itemType"><%=user.getType()%></tbl:cell>
									<tbl:cell column="name"><base:icon 
										image="deleted.gif" 
										tooltip="This item has been scheduled for deletion" 
										visible="<%=user.isRemoved()%>"
									/><%=Base.getLinkedName(ID, user, false, true)%></tbl:cell>
									<tbl:cell column="permissions">
										<%=PermissionUtil.translatePermissionsToString(permissions)%>
									</tbl:cell>
								</tbl:row>
								<%
							}
							%>
							</tbl:rows>
						</tbl:data>
					</tbl:table>
				</base:section>
				<%
			}
			else
			{
				%>
				<h4>Shared to</h4>
				This file is not shared 
				(or, you don't have permission to view the ones it is shared to).
				<%
			}
			%>
		</div>
		</form>
	</t:tab>
		<t:tab id="history" title="Change history" 
			tooltip="Displays a log of all modifications made to this item"
			visible="<%=ChangeHistoryUtil.showChangeHistoryTab(sc)%>">
			<%
			if ("history".equals(tab))
			{
				%>
				<jsp:include page="../../common/history/frameset.jsp">
					<jsp:param name="source_type" value="<%=itemType.name()%>" />
					<jsp:param name="source_id" value="<%=itemId%>" />
					<jsp:param name="ID" value="<%=ID%>" />
				</jsp:include>
				<%
			}
			%>
		</t:tab>
		</t:tabcontrol>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}

%>
