<%-- $Id: menu.jsp 5192 2009-11-23 08:27:03Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg, Gregory Vincic
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg, Martin Svensson, Gregory Vincic
	Copyright (C) 2007 Nicklas Nordborg

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	This page is included from the <base:page> taglib to display the
	meny.

	@param name
		The name of the menu to display:
		- standard: The standard menu for a logged in user
		- login: The menu used on pages where no user is logged in
		- exception: Used on error pages, does not display a menu at all
		- auto: Will display either the "standard" or "login" menu

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.BasicItem"
	import="net.sf.basedb.core.Nameable"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.core.Project"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.Client"
	import="net.sf.basedb.core.StringUtil"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Order"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.menu.MenuItemAction"
	import="net.sf.basedb.util.extensions.Extension"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="net.sf.basedb.util.extensions.ActionIterator"
	import="java.util.HashMap"
	import="java.util.Map"
	import="java.util.ArrayList"
	import="java.util.LinkedList"
	import="java.util.List"
	import="java.util.Arrays"
	import="java.util.Iterator"
%>
<%@ taglib prefix="m" uri="/WEB-INF/menu.tld" %>
<%
final SessionControl sc = Base.getSessionControl(pageContext, false);
final String ID = sc == null ? "" : sc.getId();
String name = Values.getString(request.getParameter("name"), "login");
final String root = request.getContextPath()+"/";
if ("exception".equals(name) && sc != null && sc.isLoggedIn()) name = "standard";

if ("login".equals(name))
{
}
else if ("projects".equals(name) && sc != null && sc.isLoggedIn())
{
	// Projects menu
	final ItemContext projectCC = sc.getCurrentContext(Item.PROJECT);
	int activeProjectId = sc.getActiveProjectId();
	final ItemQuery<Project> projectQuery = Project.getQuery();
	projectQuery.include(Include.MINE, Include.SHARED);
	Order projectSortOrder = projectCC.getSortOrder();
	if (projectSortOrder != null) projectQuery.order(projectSortOrder);
	projectQuery.order(Orders.asc(Hql.property("name")));
	projectQuery.setCacheResult(true);
	final DbControl dc = sc.newDbControl();
	try
	{
		%>
		<m:menu  
			id="projects"
			style="display: none"
			>
			<m:menuitem
				title="<i>- no active project -</i>"
				onclick="<%="Main.openPopup('"+root+"my_base/projects/set_active.jsp?ID="+ID+"', 'ActivateProject', 300, 140)"%>"
				icon="<%=activeProjectId == 0 ? "checkedmenu.gif" : null%>"
				enabled="<%=activeProjectId != 0%>"
				tooltip="<%=activeProjectId == 0 ? "No project is active" : "Disable the currently active project"%>"
			/>
			<%
			ItemResultList<Project> projects = projectQuery.list(dc);
			boolean breakAt20 = projects.size() > 25;
			int index = 0;
			for (Project p : projects)
			{
				if (index == 20 && breakAt20) break;
				index++;
				int projectId = p.getId();
				boolean active = activeProjectId == projectId;
				%>
				<m:menuitem
					title="<%=HTML.encodeTags(p.getName())%>"
					style="<%=active ? "color: #000000; font-weight: bold;" : null %>"
					onclick="<%="Main.openPopup('"+root+"my_base/projects/set_active.jsp?ID="+ID+"&project_id="+p.getId()+"', 'ActivateProject', 300, 140)"%>"
					icon="<%=active ? "checkedmenu.gif" : null%>"
					enabled="<%=!active%>"
					tooltip="<%=active ? "This is the active project" : "Set this project to the active project"%>"
				/>
				<%
			}
			if (breakAt20)
			{
				int more = projects.size() - 20;
				%>
				<m:menuseparator />
				<m:menuitem 
					title="<%=more + " more" %>"
					onclick="<%="Menu.openUrl('"+root+"my_base/projects/index.jsp?ID="+ID+"')"%>"
					tooltip="Show more projects"
				/>
				<%
			}
			%>
		</m:menu>
		<%
	}
	finally
	{
		if (dc != null) dc.close();
	}
}
else if ("recentItems".equals(name) && sc != null && sc.isLoggedIn())
{
	// Recently used items menu
	String stickyItems = Values.getString(sc.getUserClientSetting("menu.mostRecent"), 
		"EXPERIMENT:BIOASSAYSET:TRANSFORMATION");
	boolean loadNames = Values.getBoolean(sc.getUserClientSetting("menu.mostRecent.loadNames"), 
		true);
	String recentItems = sc.getUserClientSetting("menu.mostRecent.viewed");
	DbControl dc = loadNames ? sc.newDbControl() : null;
	try
	{
		%>
		<m:menu
			id="mostRecent"
			style="display: none;"
			>
			<%
			int numItems = 0;
			// Recently viewed items
			List<String> recentlyViewed = recentItems == null ? 
				new ArrayList<String>() : Arrays.asList(recentItems.split(":"));
			if (recentlyViewed.size() > 0)
			{
				%>
				<m:menuitem 
					title="Recently viewed items" 
					style="font-weight: bold; color: #000000; background: #e8e8e8;" 
					enabled="false" 
				/>
				<m:menuseparator />
				<%
				for (String recent : recentlyViewed)
				{
					try
					{
						String[] tmp = recent.split("=");
						Item itemType = Item.valueOf(tmp[0]);
						int itemId = Values.getInt(tmp[1], 0);
						if (itemId != 0)
						{
							String shortName = "";
							String fullName = "";
							if (loadNames)
							{
								try
								{
									BasicItem item = itemType.getById(dc, itemId);
									fullName = ((Nameable)item).getName();
									shortName = HTML.encodeTags(StringUtil.trimString(fullName, 35));
								}
								catch (Throwable t)
								{
									continue;
								}
							}
							else
							{
								fullName = itemType.toString() + "; id=" + itemId;
								shortName = itemType + " (id=" + itemId + ")";
							}
							numItems++;
							%>
							<m:menuitem
								title="<%=numItems + ". " + shortName%>"
								onclick="<%="Main.viewOrEditItem('" + ID + "', '" + itemType.name() + "', " + itemId + ")"%>"
								tooltip="<%="Go to " + HTML.encodeTags(fullName) + " (" + itemType + ")"%>"
							/>
							<%
						}
					}
					catch (Throwable t)
					{}
				}
			}
			if (stickyItems != null && stickyItems.length() > 0)
			{
				int numSticky = 0;
				if (numItems > 0)
				{
					%>
					<m:menuseparator />
					<%
				}
				%>
				<m:menuitem 
					title="Sticky items" 
					style="font-weight: bold; color: #000000; background: #e8e8e8;" 
					enabled="false" 
				/>
				<m:menuseparator />
				<%
				// Sticky items
				for (String recentItem : stickyItems.split(":"))
				{
					try
					{
						BasicItem item = null;
						Item itemType = Item.valueOf(recentItem);
						ItemContext cc = sc.getCurrentContext(itemType);
						if (cc.getId() != 0)
						{
							String shortName = "";
							String fullName = "";
							if (loadNames)
							{
								try
								{
									item = itemType.getById(dc, cc.getId());
									fullName = ((Nameable)item).getName();
									shortName = ": " + HTML.encodeTags(StringUtil.trimString(fullName, 30));
								}
								catch (Throwable t)
								{
									continue;
								}
							}
							else
							{
								fullName = itemType.toString() + "; id=" + cc.getId();
								shortName = " (id=" + cc.getId() + ")";
							}
							numItems++;
							numSticky++;
							%>
							<m:menuitem
								title="<%=itemType + shortName%>"
								onclick="<%="Main.viewOrEditItem('" + ID + "', '" + itemType.name() + "', " + cc.getId() + ")"%>"
								tooltip="<%="Go to " + HTML.encodeTags(fullName) + " (" + itemType + ")"%>"
							/>
							<%
							if (itemType == Item.BIOASSAYSET)
							{
								// Add menu for Experiment explorer as well
								%>
								<m:menuitem
									title="<%="Experiment explorer"+HTML.encodeTags(shortName)%>"
									onclick="<%="location.href = '"+root+"views/experiments/explorer/view/index.jsp?ID=" + ID + "&bioassayset_id="+cc.getId()+"'"%>"
									tooltip="Go to experiment explorer"
									visible="<%=item == null || ((BioAssaySet)item).getNumSpots() > 0 %>"
								/>
								<%
							}
						}
					}
					catch (Throwable t)
					{}
				}
				if (numSticky == 0)
				{
					%>
					<m:menuitem 
						title="<i>- no sticky items -</i>"
						enabled="false"
					/>
					<%
				}
			}
			%>
			<m:menuseparator />
			<m:menuitem 
				title="Options&hellip;" 
				onclick="<%="Main.openPopup('"+root+"my_base/user/preferences.jsp?ID="+ID+"&page=mostRecent', 'Preferences', 500, 400);"%>"
				tooltip="Change options for this menu" 
			/>
		</m:menu>
		<%
	}
	finally
	{
		if (dc != null) dc.close();
	}
}
else if ("standard".equals(name))
{
	final DbControl dc = sc.newDbControl();
	StringBuilder fillText = new StringBuilder();
	try
	{
		Project activeProject = sc.getActiveProjectId() == 0 ? null : Project.getById(dc, sc.getActiveProjectId());
		if (activeProject == null)
		{
			fillText.append("<img src=\""+root+"images/no_active_project.gif\" border=\"0\">&nbsp;");
			fillText.append("<a href=\"javascript:void(0)\" style=\"color:#FF0000;\" title=\"Set active project\"");
		}
		else
		{
			fillText.append("<img src=\""+root+"images/project.gif\" border=\"0\">&nbsp;");
			fillText.append("<a href=\"javascript:void(0)\" title=\"Switch active project\"");
		}
		
		fillText.append(" onclick=\"Menu.toggleTopMenu(document.getElementById('projects'), event.clientX-50, event.clientY); event.cancelBubble = true;\">");
		fillText.append(activeProject == null ? "<i>- no active project -</i>" : HTML.encodeTags(activeProject.getName()));
		fillText.append(" <img src=\""+root+"images/sort_asc.gif\" border=\"0\"></a><span class=\"menuseparator\">&nbsp;&nbsp;</span>");
		
		fillText.append("<a href=\"javascript:void(0)\" title=\"Refresh current page\"");
		fillText.append(" onclick=\"location.reload()\">");
		fillText.append("<img src=\""+root+"images/refresh.gif\" border=\"0\"></a><span class=\"menuseparator\">&nbsp;&nbsp;</span>");
		
		fillText.append("<a href=\"javascript:void(0)\" title=\"Go to the most recently viewed item\"");
		fillText.append(" onclick=\"Menu.toggleTopMenu(document.getElementById('mostRecent'), event.clientX-200, event.clientY); event.cancelBubble = true;\">");
		fillText.append(" <img src=\""+root+"images/recent.png\" border=\"0\"><img src=\""+root+"images/sort_asc.gif\" border=\"0\"></a><span class=\"menuseparator\">&nbsp;&nbsp;</span>");
		
		User user = User.getById(dc, sc.getLoggedInUserId());
		String userPrompt = sc.isImpersonated() ? "Impersonated" : "User";
		fillText.append("<img src=\""+root+"images/take_ownership.png\" border=\"0\"> <a href=\"javascript:void(0)\" title=\"Switch user/logout\"");
		fillText.append(" onclick=\"javascript:Menu.toggleTopMenu(document.getElementById('switchuser'), event.clientX-100, event.clientY); event.cancelBubble = true;\">");
		fillText.append(HTML.encodeTags(user.getLogin()));
		fillText.append(" (").append(user.getName()).append(") <img src=\""+root+"images/sort_asc.gif\" border=\"0\"></a>");
		%>
		<%
		// Permission settings
		final boolean hasFiles              = !sc.hasPermission(Permission.DENIED, Item.FILE);
		final boolean createFiles           =  sc.hasPermission(Permission.CREATE, Item.FILE);

		final boolean hasProjects           = !sc.hasPermission(Permission.DENIED, Item.PROJECT); 
		final boolean createProjects        =  sc.hasPermission(Permission.CREATE, Item.PROJECT); 

		final boolean hasMessages           = !sc.hasPermission(Permission.DENIED, Item.MESSAGE); 
		final boolean createMessages        =  sc.hasPermission(Permission.CREATE, Item.MESSAGE); 

		final boolean hasHybridizations     = !sc.hasPermission(Permission.DENIED, Item.HYBRIDIZATION); 
		final boolean createHybridizations  =  sc.hasPermission(Permission.CREATE, Item.HYBRIDIZATION); 

		final boolean hasScans              = !sc.hasPermission(Permission.DENIED, Item.SCAN); 
		final boolean createScans           =  sc.hasPermission(Permission.CREATE, Item.SCAN); 
		final boolean hasRawBioAssays       = !sc.hasPermission(Permission.DENIED, Item.RAWBIOASSAY); 
		final boolean createRawBioAssays    =  sc.hasPermission(Permission.CREATE, Item.RAWBIOASSAY); 
		final boolean hasExperiments        = !sc.hasPermission(Permission.DENIED, Item.EXPERIMENT); 
		final boolean createExperiments     =  sc.hasPermission(Permission.CREATE, Item.EXPERIMENT); 
		final boolean hasFormulas           = !sc.hasPermission(Permission.DENIED, Item.FORMULA); 
		final boolean createFormulas        =  sc.hasPermission(Permission.CREATE, Item.FORMULA); 
		
		final boolean hasReporters          = !sc.hasPermission(Permission.DENIED, Item.REPORTER); 
		final boolean hasReporterLists      = !sc.hasPermission(Permission.DENIED, Item.REPORTERLIST); 
		final boolean createReporters       =  sc.hasPermission(Permission.CREATE, Item.REPORTER); 
		final boolean hasJobs               = !sc.hasPermission(Permission.DENIED, Item.JOB); 
		final boolean hasSessions           = !sc.hasPermission(Permission.DENIED, Item.SESSION); 
		%>
		<m:menu
			id="view"
			style="display: none"
			>
			<m:menuitem
				title="Home" 
				onclick="<%="Menu.openUrl('"+root+"my_base/index.jsp?ID="+ID+"')"%>" 
			/>
			<m:menuitem
				title="All items"
				tooltip="View all items that you are the owner of"
				onclick="<%="Menu.openUrl('"+root+"views/items/index.jsp?ID="+ID+"')"%>"
			/>
			<m:menuitem
				title="Trashcan"
				tooltip="View all items that have been marked for deletion"
				onclick="<%="Menu.openUrl('"+root+"views/trashcan/index.jsp?ID="+ID+"')"%>"
			/>
			<m:menuseparator />
			<m:menuitem 
				title="Files" 
				onclick="<%="Menu.openUrl('"+root+"filemanager/index.jsp?ID="+ID+"')"%>" 
				tooltip="<%=hasFiles ? "Manage files" : "You do not have permission to manage files"%>" 
				enabled="<%=hasFiles%>"
			/>
			<m:menuitem
				title="Projects"
				onclick="<%="Menu.openUrl('"+root+"my_base/projects/index.jsp?ID="+ID+"')"%>"
				tooltip="Manage projects"
				enabled="<%=hasProjects%>"
			/>
			<m:menuitem 
				title="Messages" 
				onclick="<%="Menu.openUrl('"+root+"my_base/messages/index.jsp?ID="+ID+"')"%>" 
				tooltip="<%=hasMessages ? "Read your messages" : "You do not have permission to read messages"%>" 
				enabled="<%=hasMessages%>"
			/>
			<m:menuitem 
				title="Jobs" 
				onclick="<%="Menu.openUrl('"+root+"views/jobs/index.jsp?ID="+ID+"')"%>" 
				tooltip="<%=hasJobs ? "Check the status of your jobs" : "You do not have permission to access jobs"%>" 
				enabled="<%=hasJobs%>"
			/>
			<m:menuitem 
				title="Sessions" 
				onclick="<%="Menu.openUrl('"+root+"views/sessions/index.jsp?ID="+ID+"')"%>" 
				tooltip="<%=hasSessions ? "Check you login sessions" : "You do not have permission to access sessions"%>" 
				enabled="<%=hasSessions%>"
			/>
			<m:menuseparator />
			<m:menuitem
				title="Hybridizations"
				onclick="<%="Menu.openUrl('"+root+"views/hybridizations/index.jsp?ID="+ID+"')"%>"
				tooltip="<%=hasHybridizations ? "Manage hybridizations" : "You do not have permission to manage hybridizations"%>"
				enabled="<%=hasHybridizations%>"
			/>
			<m:menuitem
				title="Scans"
				onclick="<%="Menu.openUrl('"+root+"views/scans/index.jsp?ID="+ID+"')"%>"
				tooltip="<%=hasScans ? "Manage scans" : "You do not have permission to manage scans"%>"
				enabled="<%=hasScans%>"
			/>
			<m:menuitem
				title="Raw bioassays"
				onclick="<%="Menu.openUrl('"+root+"views/rawbioassays/index.jsp?ID="+ID+"')"%>"
				tooltip="<%=hasRawBioAssays ? "Manage raw bioassays" : "You do not have permission to manage raw bioassays"%>"
				enabled="<%=hasRawBioAssays%>"
			/>
			<m:menuitem
				title="Experiments"
				onclick="<%="Menu.openUrl('"+root+"views/experiments/index.jsp?ID="+ID+"')"%>"
				tooltip="<%=hasExperiments ? "Manage experiments" : "You do not have permission to manage experiments"%>"
				enabled="<%=hasExperiments%>"
			/>
			<m:menuitem
				title="Formulas"
				onclick="<%="Menu.openUrl('"+root+"views/formulas/index.jsp?ID="+ID+"')"%>"
				tooltip="<%=hasFormulas ? "Manage formulas" : "You do not have permission to manage formulas"%>"
				enabled="<%=hasFormulas%>"
			/>
			<m:menuseparator />
			<m:menuitem
				title="Reporters"
				onclick="<%="Menu.openUrl('"+root+"views/reporters/index.jsp?ID="+ID+"')"%>"
				tooltip="<%=hasReporters ? "Manage reporters" : "You do not have permission to manage reporters"%>"
				enabled="<%=hasReporters%>"
			/>
			<m:menuitem
				title="Reporter lists"
				onclick="<%="Menu.openUrl('"+root+"views/reporterlists/index.jsp?ID="+ID+"')"%>"
				tooltip="<%=hasReporterLists ? "Manage reporter lists" : "You do not have permission to manage reporter lists"%>"
				enabled="<%=hasReporterLists%>"
			/>
		</m:menu>

		<m:menu 
			id="base" 
			style="display: none"
			>
			<m:submenu 
				subid="projects" 
				title="Select project"
				enabled="<%=hasProjects%>"
			/>
			<m:menuseparator />
			<m:menuitem 
				title="Contact information&hellip;" 
				onclick="<%="Main.openPopup('"+root+"my_base/user/settings.jsp?ID="+ID+"&page=contact', 'Settings', 500, 360);"%>" 
				tooltip="Set your address, phone, email, etc." 
			/>
			<m:menuitem 
				title="Change password&hellip;" 
				onclick="<%="Main.openPopup('"+root+"my_base/user/settings.jsp?ID="+ID+"&page=password', 'Settings', 500, 360);"%>" 
				tooltip="Set your password" 
			/>
			<m:menuitem 
				title="Other information&hellip;"  
				onclick="<%="Main.openPopup('"+root+"my_base/user/settings.jsp?ID="+ID+"&page=other', 'Settings', 500, 360);"%>" 
				tooltip="Other user-related information" 
			/>
			<m:menuseparator />
			<m:menuitem 
				title="Preferences&hellip;" 
				onclick="<%="Main.openPopup('"+root+"my_base/user/preferences.jsp?ID="+ID+"', 'Preferences', 500, 400);"%>" 
				tooltip="Change font sizes, etc." 
			/>
			<m:menuitem 
				title="Reload permissions" 
				onclick="<%="Main.openPopup('"+root+"my_base/user/submit_user.jsp?ID="+ID+"&cmd=ReloadPermissions', 'ReloadPermissions', 300, 200);"%>" 
				tooltip="Reload permissions" 
			/>
			<m:menuitem 
				title="Reset list settings&hellip;" 
				onclick="<%="Main.openPopup('"+root+"my_base/user/reset_filters.jsp?ID="+ID+"', 'ResetFilter', 400, 300);"%>" 
				tooltip="Reset visible columns, sort order, filters, etc. to default settings on all lists" 
			/>
			<m:menuseparator />
			<m:menuitem 
				title="Logout&hellip;" 
				onclick="<%="Main.openPopup('"+root+"logout.jsp?ID="+ID+"', 'Logout', 360, 200);"%>"
				tooltip="Exit from BASE" 
			/>
		</m:menu>

		<%
		// BioLIMS - menu	
		final boolean hasLabels             = !sc.hasPermission(Permission.DENIED, Item.LABEL); 
		final boolean createLabels          =  sc.hasPermission(Permission.CREATE, Item.LABEL); 

		final boolean hasBioSources         = !sc.hasPermission(Permission.DENIED, Item.BIOSOURCE); 
		final boolean createBioSources      =  sc.hasPermission(Permission.CREATE, Item.BIOSOURCE); 

		final boolean hasSamples            = !sc.hasPermission(Permission.DENIED, Item.SAMPLE); 
		final boolean createSamples         =  sc.hasPermission(Permission.CREATE, Item.SAMPLE);

		final boolean hasExtracts           = !sc.hasPermission(Permission.DENIED, Item.EXTRACT); 
		final boolean createExtracts        =  sc.hasPermission(Permission.CREATE, Item.EXTRACT); 

		final boolean hasLabeledExtracts    = !sc.hasPermission(Permission.DENIED, Item.LABELEDEXTRACT); 
		final boolean createLabeledExtracts =  sc.hasPermission(Permission.CREATE, Item.LABELEDEXTRACT); 
		
		final boolean hasBioMaterialLists   = !sc.hasPermission(Permission.DENIED, Item.BIOMATERIALLIST);
		
		final boolean hasBioPlates			= !sc.hasPermission(Permission.DENIED, Item.BIOPLATE);
		final boolean createBioPlates		=  sc.hasPermission(Permission.CREATE, Item.BIOPLATE);
		final boolean hasBioLims			=  hasLabels || hasBioSources || hasSamples || hasExtracts || 
													hasLabeledExtracts || hasBioMaterialLists;
		
		if (hasBioLims)
		{
		%>
			<m:menu 
				id="biolims"
				style="display: none"
				>
				<m:menuitem
					title="Biosources"
					onclick="<%="Menu.openUrl('"+root+"biomaterials/biosources/index.jsp?ID="+ID+"')"%>"
					tooltip="<%=hasBioSources ? "Manage biosources" : "You do not have permission to manage biosources"%>"
					enabled="<%=hasBioSources%>"
				/>
				<m:menuitem
					title="Samples"
					onclick="<%="Menu.openUrl('"+root+"biomaterials/samples/index.jsp?ID="+ID+"')"%>"
					tooltip="<%=hasSamples ? "Manage samples" : "You do not have permission to manage samples"%>"
					enabled="<%=hasSamples%>"
				/>
				<m:menuitem
					title="Extracts"
					onclick="<%="Menu.openUrl('"+root+"biomaterials/extracts/index.jsp?ID="+ID+"')"%>"
					tooltip="<%=hasExtracts ? "Manage extracts" : "You do not have permission to manage extracts"%>"
					enabled="<%=hasExtracts%>"
				/>
				<m:menuitem
					title="Labeled extracts"
					onclick="<%="Menu.openUrl('"+root+"biomaterials/labeledextracts/index.jsp?ID="+ID+"')"%>"
					tooltip="<%=hasLabeledExtracts ? "Manage labeled extracts" : "You do not have permission to manage labeled extracts"%>"
					enabled="<%=hasLabeledExtracts%>"
				/>
				<m:menuitem
					title="Labels"
					onclick="<%="Menu.openUrl('"+root+"biomaterials/labels/index.jsp?ID="+ID+"')"%>"
					tooltip="<%=hasLabels ? "Manage labels" : "You do not have permission to manage labels"%>"
					enabled="<%=hasLabels%>"
				/>
				<m:menuseparator />
				<m:menuitem
					title="Bioplates"
					onclick="<%="Menu.openUrl('"+root+"biomaterials/bioplates/index.jsp?ID="+ID+"')"%>"
					tooltip="<%=hasBioPlates ? "Manage bio plates" : "You do not have permission to manage bio plates"%>"
					enabled="<%=hasBioPlates%>"
				/>
				<m:menuitem
					title="Biomaterial lists"
					onclick="<%="Menu.openUrl('"+root+"biomaterials/lists/index.jsp?ID="+ID+"')"%>"
					tooltip="<%=hasBioMaterialLists ? "Manage biomaterial lists" : "You do not have permission to manage biomaterial lists"%>"
					enabled="<%=hasBioMaterialLists%>"
				/>
			</m:menu>
		<%
		}
		
		// Array LIMS - menu
		final boolean hasPlateGeometries = sc.hasPermission(Permission.READ, Item.PLATEGEOMETRY);
		final boolean hasPlateTypes = !sc.hasPermission(Permission.DENIED, Item.PLATETYPE);
		final boolean hasPlates = !sc.hasPermission(Permission.DENIED, Item.PLATE);
		final boolean hasPlateMappings = !sc.hasPermission(Permission.DENIED, Item.PLATEMAPPING);
		final boolean hasArraySlides = !sc.hasPermission(Permission.DENIED, Item.ARRAYSLIDE);
		final boolean hasArrayBatches = !sc.hasPermission(Permission.DENIED, Item.ARRAYBATCH);
		final boolean hasArrayDesigns = !sc.hasPermission(Permission.DENIED, Item.ARRAYDESIGN);
		final boolean hasLims = hasPlateGeometries || hasPlateTypes || hasPlates || hasPlateMappings || 
			hasArraySlides || hasArrayBatches || hasArrayDesigns;
		if (hasLims)
		{
			%>
			<m:menu 
				id="lims" 
				style="display: none"
				>
				<m:menuitem 
					title="Plate geometries" 
					onclick="<%="Menu.openUrl('"+root+"lims/geometries/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasPlateGeometries ? "Manage plate geometries" : "You do not have permission to manage plate geometries"%>" 
					enabled="<%=hasPlateGeometries%>"
				/>
				<m:menuitem 
					title="Plate types" 
					onclick="<%="Menu.openUrl('"+root+"lims/platetypes/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasPlateTypes ? "Manage plate types" : "You do not have permission to manage plate types"%>" 
					enabled="<%=hasPlateTypes%>"
				/>
				<m:menuitem 
					title="Plates" 
					onclick="<%="Menu.openUrl('"+root+"lims/plates/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasPlates ? "Manage plates" : "You do not have permission to manage plates"%>" 
					enabled="<%=hasPlates%>"
				/>
				<m:menuitem 
					title="Plate mappings" 
					onclick="<%="Menu.openUrl('"+root+"lims/platemappings/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasPlateTypes ? "Manage plate mappings" : "You do not have permission to manage plate mappings"%>" 
					enabled="<%=hasPlateTypes%>"
				/>
				<m:menuseparator />
				<m:menuitem 
					title="Array designs" 
					onclick="<%="Menu.openUrl('"+root+"lims/arraydesigns/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasArrayDesigns ? "Manage array designs" : "You do not have permission to manage array designs"%>" 
					enabled="<%=hasArrayDesigns%>"
				/>
				<m:menuitem 
					title="Array batches" 
					onclick="<%="Menu.openUrl('"+root+"lims/arraybatches/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasArrayBatches ? "Manage array batches" : "You do not have permission to manage array batches"%>" 
					enabled="<%=hasArrayBatches%>"
				/>
				<m:menuitem 
					title="Array slides" 
					onclick="<%="Menu.openUrl('"+root+"lims/arrayslides/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasArraySlides ? "Manage array slides" : "You do not have permission to manage array slides"%>" 
					enabled="<%=hasArraySlides%>"
				/>
			</m:menu>
			<%
		}
		%>
		<%
		// Administrate -> Types menu
		final boolean hasQuotaTypes = sc.hasPermission(Permission.READ, Item.QUOTATYPE);
		final boolean hasProtocolTypes = sc.hasPermission(Permission.READ, Item.PROTOCOLTYPE);
		final boolean hasFileTypes = sc.hasPermission(Permission.READ, Item.FILETYPE);
		final boolean hasMimeTypes = sc.hasPermission(Permission.READ, Item.MIMETYPE);
		final boolean hasHardwareTypes = sc.hasPermission(Permission.READ, Item.HARDWARETYPE);
		final boolean hasSoftwareTypes = sc.hasPermission(Permission.READ, Item.SOFTWARETYPE);
		final boolean hasAnnotationTypeCategories = !sc.hasPermission(Permission.DENIED, Item.ANNOTATIONTYPECATEGORY);		
		final boolean hasAnnotationTypes = !sc.hasPermission(Permission.DENIED, Item.ANNOTATIONTYPE);
		final boolean hasReporterTypes = !sc.hasPermission(Permission.DENIED, Item.REPORTERTYPE);
		final boolean hasExtraValueTypes = !sc.hasPermission(Permission.DENIED, Item.EXTRAVALUETYPE);
		final boolean hasQuantities = !sc.hasPermission(Permission.DENIED, Item.QUANTITY);
		final boolean hasTypes = hasFileTypes || hasProtocolTypes || hasMimeTypes || hasQuotaTypes || 
			hasSoftwareTypes || hasHardwareTypes || hasAnnotationTypeCategories || hasAnnotationTypes || 
			hasReporterTypes || hasExtraValueTypes || hasQuantities;
		if (hasTypes)
		{
			%>
			<m:menu 
				id="types" 
				style="display: none"
				>
				<m:menuitem 
					title="Quota types" 
					onclick="<%="Menu.openUrl('"+root+"admin/quotatypes/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasQuotaTypes ? "Administrate quota types" : "You do not have permission to administrate quota types"%>" 
					enabled="<%=hasQuotaTypes%>"
				/>
				<m:menuitem 
					title="Protocol types" 
					onclick="<%="Menu.openUrl('"+root+"admin/protocoltypes/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasProtocolTypes ? "Administrate protocol types" : "You do not have permission to administrate protocol types"%>" 
					enabled="<%=hasProtocolTypes%>"
				/>
				<m:menuitem 
					title="File types" 
					onclick="<%="Menu.openUrl('"+root+"admin/filetypes/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasFileTypes ? "Administrate file types" : "You do not have permission to administrate file types"%>" 
					enabled="<%=hasFileTypes%>"
				/>
				<m:menuitem 
					title="MIME types" 
					onclick="<%="Menu.openUrl('"+root+"admin/mimetypes/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasMimeTypes ? "Administrate MIME types" : "You do not have permission to administrate mime types"%>" 
					enabled="<%=hasMimeTypes%>"
				/>
				<m:menuitem 
					title="Software types" 
					onclick="<%="Menu.openUrl('"+root+"admin/softwaretypes/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasSoftwareTypes ? "Administrate software types" : "You do not have permission to administrate software types"%>" 
					enabled="<%=hasSoftwareTypes%>"
				/>
				<m:menuitem 
					title="Hardware types" 
					onclick="<%="Menu.openUrl('"+root+"admin/hardwaretypes/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasHardwareTypes ? "Administrate hardware types" : "You do not have permission to administrate hardware types"%>" 
					enabled="<%=hasHardwareTypes%>"
				/>
				<m:menuitem 
					title="Annotation type categories" 
					onclick="<%="Menu.openUrl('"+root+"admin/annotationtypecategories/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasAnnotationTypeCategories ? "Administrate annotation type categories" : "You do not have permission to administrate annotation types categories"%>" 
					enabled="<%=hasAnnotationTypeCategories%>"
				/>
				<m:menuitem 
					title="Annotation types" 
					onclick="<%="Menu.openUrl('"+root+"admin/annotationtypes/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasAnnotationTypes ? "Administrate annotation types" : "You do not have permission to administrate annotation types"%>" 
					enabled="<%=hasAnnotationTypes%>"
				/>
				<m:menuitem 
					title="Units and quantities" 
					onclick="<%="Menu.openUrl('"+root+"admin/quantities/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasQuantities ? "Administrate quantities" : "You do not have permission to administrate quantities"%>" 
					enabled="<%=hasQuantities%>"
				/>
				<m:menuitem 
					title="Reporter types" 
					onclick="<%="Menu.openUrl('"+root+"admin/reportertypes/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasReporterTypes ? "Administrate reporter types" : "You do not have permission to administrate reporter types"%>" 
					enabled="<%=hasReporterTypes%>"
				/>
				<m:menuitem 
					title="Extra value types" 
					onclick="<%="Menu.openUrl('"+root+"admin/extravaluetypes/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasExtraValueTypes ? "Administrate extra value types" : "You do not have permission to administrate extra value types"%>" 
					enabled="<%=hasExtraValueTypes%>"
				/>
			</m:menu>
			<%
		}
		%>
		<%
		// Administrate -> Platforms menu
		final boolean hasPlatforms = sc.hasPermission(Permission.READ, Item.PLATFORM);
		final boolean hasFileSetMemberTypes = sc.hasPermission(Permission.READ, Item.DATAFILETYPE);
		final boolean hasTopPlatforms = hasPlatforms || hasFileSetMemberTypes;
		if (hasTopPlatforms)
		{
			%>
			<m:menu 
				id="platforms"
				style="display: none"
				>
				<m:menuitem 
					title="Experimental platforms"
					onclick="<%="Menu.openUrl('"+root+"admin/platforms/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasPlatforms ? "Administrate experimental platforms" : "You do not have permission to administrate experimental platforms"%>"
					enabled="<%=hasPlatforms%>"
				/>
				<m:menuitem 
					title="Data file types"
					onclick="<%="Menu.openUrl('"+root+"admin/datafiletypes/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasFileSetMemberTypes ? "Administrate data file types" : "You do not have permission to administrate data file types"%>"
					enabled="<%=hasFileSetMemberTypes%>"
				/>
			</m:menu>
			<%
		}
		%>
		
		<%
		// Plugins menu
		final boolean hasPluginTypes = !sc.hasPermission(Permission.DENIED, Item.PLUGINTYPE);
		final boolean hasPluginDefinitions = !sc.hasPermission(Permission.DENIED, Item.PLUGINDEFINITION);
		final boolean hasPluginConfigurations = !sc.hasPermission(Permission.DENIED, Item.PLUGINCONFIGURATION);
		final boolean hasJobAgents = sc.hasPermission(Permission.READ, Item.JOBAGENT);
		final boolean hasPlugins = hasPluginTypes || hasPluginDefinitions || 
			hasPluginConfigurations || hasJobAgents;
		
		if (hasPlugins)
		{
			%>
			<m:menu 
				id="plugins" 
				style="display: none"
				>
				<m:menuitem 
					title="Types" 
					onclick="<%="Menu.openUrl('"+root+"admin/plugintypes/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasPluginDefinitions ? "Administrate plugin types" : "You do not have permission to administrate plugin types"%>"
					enabled="<%=hasPluginTypes%>"
				/>
				<m:menuitem 
					title="Definitions" 
					onclick="<%="Menu.openUrl('"+root+"admin/plugindefinitions/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasPluginDefinitions ? "Administrate plugin definitions" : "You do not have permission to administrate plugin definitions"%>"
					enabled="<%=hasPluginDefinitions%>"
				/>
				<m:menuitem 
					title="Configurations" 
					onclick="<%="Menu.openUrl('"+root+"admin/pluginconfigurations/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasPluginConfigurations ? "Administrate plugin configurations" : "You do not have permission to administrate plugin configurations"%>"
					enabled="<%=hasPluginConfigurations%>"
				/>
				<m:menuseparator />
				<m:menuitem 
					title="Job agents" 
					onclick="<%="Menu.openUrl('"+root+"admin/jobagents/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasJobAgents ? "Administrate job agents" : "You do not have permission to administrate job agents"%>"
					enabled="<%=hasJobAgents%>"
				/>
			</m:menu>
			<%
		}
		%>
	
		<%
		// Administrate menu
		final boolean hasUsers = !sc.hasPermission(Permission.DENIED, Item.USER);
		final boolean hasGroups = !sc.hasPermission(Permission.DENIED, Item.GROUP);
		final boolean hasRoles = sc.hasPermission(Permission.READ, Item.ROLE);
		final boolean hasQuota = sc.hasPermission(Permission.READ, Item.QUOTA);
		final boolean hasSoftware = !sc.hasPermission(Permission.DENIED, Item.SOFTWARE);
		final boolean hasHardware = !sc.hasPermission(Permission.DENIED, Item.HARDWARE);
		final boolean hasProtocols = !sc.hasPermission(Permission.DENIED, Item.PROTOCOL);
		final boolean hasClients = sc.hasPermission(Permission.READ, Item.CLIENT);
		final boolean hasNews = sc.hasPermission(Permission.READ, Item.NEWS);
		final boolean hasDiskUsage = sc.hasPermission(Permission.READ, Item.DISKUSAGE);
		final Client currentClient = Client.getById(dc, sc.getClientId());
		final boolean hasServer = currentClient.hasPermission(Permission.WRITE);

		final boolean hasAdministrate = 
			hasUsers || hasGroups || hasRoles || hasQuota || hasTypes || hasPlugins ||
			hasSoftware || hasHardware || hasProtocols || hasClients || hasNews ||
			hasDiskUsage || hasServer || hasTopPlatforms;

		if (hasAdministrate)
		{
			%>
			<m:menu 
				id="administrate" 
				style="display: none"
				>
				<m:menuitem 
					title="Users" 
					onclick="<%="Menu.openUrl('"+root+"admin/users/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasUsers ? "Administrate users" : "You do not have permission to administrate users"%>"
					enabled="<%=hasUsers%>"
				/>
				<m:menuitem 
					title="Groups" 
					onclick="<%="Menu.openUrl('"+root+"admin/groups/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasGroups ? "Administrate groups" : "You do not have permission to administrate groups"%>" 
					enabled="<%=hasGroups%>"
				/>
				<m:menuitem 
					title="Roles" 
					onclick="<%="Menu.openUrl('"+root+"admin/roles/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasRoles ? "Administrate roles" : "You do not have permission to administrate roles"%>" 
					enabled="<%=hasRoles%>"
				/>
				<m:menuseparator />
				<m:submenu 
					subid="plugins" 
					title="Plugins"
					tooltip="Administrate plugin definitions and configurations"
					enabled="<%=hasPlugins%>"
				/>
				<m:menuseparator />
				<m:menuitem 
					title="Quota" 
					onclick="<%="Menu.openUrl('"+root+"admin/quota/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasQuota ? "Administrate quota" : "You do not have permission to administrate quota"%>" 
					enabled="<%=hasQuota%>"
				/>
				<m:menuitem 
					title="Software" 
					onclick="<%="Menu.openUrl('"+root+"admin/software/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasSoftware ? "Administrate software" : "You do not have permission to administrate software"%>" 
					enabled="<%=hasSoftware%>"
				/>
				<m:menuitem 
					title="Hardware" 
					onclick="<%="Menu.openUrl('"+root+"admin/hardware/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasHardware ? "Administrate hardware" : "You do not have permission to administrate hardware"%>" 
					enabled="<%=hasHardware%>"
				/>
				<m:menuitem 
					title="Protocols" 
					onclick="<%="Menu.openUrl('"+root+"admin/protocols/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasProtocols ? "Administrate protocols" : "You do not have permission to administrate protocols"%>" 
					enabled="<%=hasProtocols%>"
				/>
				<m:menuitem 
					title="Clients" 
					onclick="<%="Menu.openUrl('"+root+"admin/clients/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasClients ? "Administrate client applications" : "You do not have permission to administrate client applications"%>" 
					enabled="<%=hasClients%>"
				/>
				<m:menuitem 
					title="News" 
					onclick="<%="Menu.openUrl('"+root+"admin/news/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasNews ? "Administrate news" : "You do not have permission to administrate news"%>" 
					enabled="<%=hasNews%>"
				/>
				<m:menuseparator />
				<m:submenu 
					subid="platforms" 
					title="Platforms"
					tooltip="Administrate experimental platforms"
					enabled="<%=hasTopPlatforms%>"
				/>
				<m:submenu 
					subid="types" 
					title="Types"
					tooltip="Administrate quota, file, hardware and software types"
					enabled="<%=hasTypes%>"
				/>
				<m:menuseparator />
				<m:menuitem 
					title="Disk usage" 
					onclick="<%="Menu.openUrl('"+root+"admin/diskusage/index.jsp?ID="+ID+"')"%>" 
					tooltip="<%=hasDiskUsage ? "Check disk usage" : "You do not have permission to check disk usage"%>" 
					enabled="<%=hasDiskUsage%>"
				/>
				<m:menuitem 
					title="Server settings&hellip;"
					onclick="<%="Main.openPopup('"+root+"admin/server/configure.jsp?ID="+ID+"', 'ServerSettings', 500, 400);"%>"
					tooltip="<%=hasServer ? "Configure the server" : "You do not have permission to configure the server"%>"
					enabled="<%=hasServer%>"
				/>
				<m:menuitem 
					title="Broadcast message&hellip;"
					onclick="<%="Main.openPopup('"+root+"admin/server/broadcast.jsp?ID="+ID+"', 'BroadcastMessage', 640, 400);"%>"
					tooltip="<%=hasServer ? "Broadcast a message to all logged in users" : "You do not have permission to send messages"%>"
					enabled="<%=hasServer%>"
				/>
				<m:menuitem
					title="Services"
					tooltip="<%=hasServer ? "Manage service extensions" : "You do not have permission to manage services" %>"
					onclick="<%="Menu.openUrl('"+root+"admin/services/index.jsp?ID="+ID+"')"%>"
					enabled="<%=hasServer%>"
				/>
			</m:menu>
			<%
		}
		%>
		<%
		// Help menu
		final String helplink = Values.getStringOrNull(sc.getClientDefaultSetting("server.links.help"));
		final String faqlink = Values.getStringOrNull(sc.getClientDefaultSetting("server.links.faq"));
		final String reportbuglink = Values.getStringOrNull(sc.getClientDefaultSetting("server.links.reportbug"));
		%>
		<m:menu id="help" style="display: none">
			<m:menuitem
				visible="<%=HTML.isValidUrl(helplink)%>"
				title="Help&hellip;"
				onclick="<%="window.open('"+helplink+"','Help')"%>"
			/>
			<m:menuitem
				visible="<%=HTML.isValidUrl(faqlink)%>"
				title="FAQ&hellip;"
				onclick="<%="window.open('"+faqlink+"','FAQ')"%>"
			/>
			<m:menuseparator />

			<m:menuitem
				title="About&hellip;"
				onclick="<%="Main.openPopup('"+root+"info/about.jsp?ID="+ID+"&page=about', 'About', 500, 350)"%>"
			/>

			<m:menuitem
				title="License&hellip;"
				onclick="<%="Main.openPopup('"+root+"info/about.jsp?ID="+ID+"&page=license', 'About', 500, 350)"%>"

			/>
			<m:menuitem
				visible="<%=HTML.isValidUrl(reportbuglink)%>"
				title="Report a bug&hellip;"
				onclick="<%="window.open('"+reportbuglink+"','Reportbug')"%>"
			/>
			<m:menuseparator />
			<m:menuitem
				title="Base project site" onclick="<%="Menu.openUrl('http://base.thep.lu.se', 'basesite')"%>"
			/>
		</m:menu>
		
		<%
		//Switch user/logout menu
		final boolean hasImpersonate = 
			!sc.isImpersonated() && sc.hasSystemPermission(Permission.ACT_AS_ANOTHER_USER);
		%>
		<m:menu
			id="switchuser"
			style="display: none;"
			>
			<m:menuitem 
				title="Switch user&hellip;" 
				onclick="<%="Main.openPopup('"+root+"switch.jsp?ID="+ID+"', 'Switch', 360, 200);"%>"
				tooltip="Login as another user" 
			/>
			<m:menuitem 
				title="Impersonate&hellip;" 
				onclick="<%="Main.openPopup('"+root+"impersonate.jsp?ID="+ID+"', 'Impersonate', 480, 240);"%>"
				tooltip="Login as another user without knowing the password" 
				visible="<%=hasImpersonate%>"
			/>
			<m:menuitem 
				title="Logout&hellip;" 
				onclick="<%="Main.openPopup('"+root+"logout.jsp?ID="+ID+"', 'Logout', 360, 200);"%>"
				tooltip="Exit from BASE" 
			/>
		</m:menu>
		
		<%
		// Extensions menu
		JspContext context = ExtensionsControl.createContext(dc, pageContext);
		ExtensionsInvoker<MenuItemAction> invoker = 
			(ExtensionsInvoker<MenuItemAction>)ExtensionsControl.useExtensions(context, 
				"net.sf.basedb.clients.web.menu.extensions");
		ExtensionsControl ec = ExtensionsControl.get(dc);
		ActionIterator<MenuItemAction> it = invoker.iterate();
		Map<String, List<MenuItemAction>> menus = new HashMap<String, List<MenuItemAction>>();
		menus.put("extensions", new LinkedList<MenuItemAction>());
		while (it.hasNext())
		{
			MenuItemAction action = it.next();
			String menuId = action.getMenuId();
			menuId = menuId == null ? "extensions" : "extensions." + menuId;
			List<MenuItemAction> actions = menus.get(menuId);
			if (actions == null)
			{
				actions = new LinkedList<MenuItemAction>();
				menus.put(menuId, actions);
			}
			actions.add(action);
		}
		
		for (Map.Entry<String, List<MenuItemAction>> entry : menus.entrySet())
		{
			String menuId = entry.getKey();
			List<MenuItemAction> actions = entry.getValue();
			%>
			<m:menu id="<%=menuId%>" style="display: none;">
			<%
			for (MenuItemAction action : actions)
			{
				if (action.getType() == MenuItemAction.MenuType.SEPARATOR)
				{
					%>
					<m:menuseparator style="<%=action.getStyle()%>" visible="<%=action.isVisible()%>" />
					<%
				}
				else if (action.getType() == MenuItemAction.MenuType.MENUITEM)
				{
					%>
					<m:menuitem 
						style="<%=action.getStyle()%>"
						title="<%=action.getTitle()%>"
						icon="<%=action.getIcon()%>"
						iconabsolute="true"
						tooltip="<%=action.getTooltip()%>"
						enabled="<%=action.isEnabled()%>"
						visible="<%=action.isVisible()%>"
						onclick="<%=action.getOnClick()%>"
					/>
					<%
				}
				else if (action.getType() == MenuItemAction.MenuType.SUBMENU)
				{
					%>
					<m:submenu 
						subid="<%="extensions." + action.getSubmenuId()%>"
						style="<%=action.getStyle()%>"
						title="<%=action.getTitle()%>"
						icon="<%=action.getIcon()%>"
						iconabsolute="true"
						tooltip="<%=action.getTooltip()%>"
						enabled="<%=action.isEnabled()%>"
						visible="<%=action.isVisible()%>"
					/>
					<%
				}
			}
			if ("extensions".equals(menuId))
			{
				if (actions.size() > 0)
				{
					%>
					<m:menuseparator />
					<%
				}
				%>
				<m:menuitem
					title="Installed extensions"
					onclick="<%="Menu.openUrl('"+root+"admin/extensions/index.jsp?ID="+ID+"')"%>"
					tooltip="Display and administrate installed extensions"
				/>
				<m:menuitem 
					title="Manual scan&hellip;" 
					onclick="<%="Main.openPopup('"+root+"admin/extensions/manual_scan.jsp?ID=" + ID + "', 'ManualScan', 500, 400);"%>" 
					enabled="<%=ec.hasPermission(Permission.WRITE)%>"
					tooltip="Start a manual scan for new, updated and deleted extensions"
				/>
				<%
			}
			%>
			</m:menu>
			<%
		}
		%>
		
		<%
		// Main menu
		%>
		<div style="position: fixed; top: 0px; left: 0px; width: 100%; height: 30px; background: #ffffff;">
		<m:menu
			type="horizontal"
			clazz="menu_horizontal"
			id="menubar"
			style="top: 5px; left: 8px; width: 98%"
			open="click"
			filltext="<%=fillText.toString()%>"
			>
			<m:submenu
				subid="base"
				title="BASE"
			/>
			<m:submenu
				subid="view"
				title="View"
			/>
			<m:submenu 
				subid="biolims"
				title="Biomaterial LIMS"
			/>
			<m:submenu
				subid="lims"
				title="Array LIMS"
			/>
			<m:submenu
				subid="administrate"
				title="Administrate"
				visible="<%=hasAdministrate%>"
			/>
			<m:submenu
				subid="extensions"
				title="Extensions"
			/>
			<m:submenu
				subid="help"
				title="Help"
			/>
		</m:menu></div>
		<br><br>
		<%
	}
	finally
	{
		if (dc != null) dc.close();
	}

}
%>



