<%-- $Id: reset_filters.jsp 4889 2009-04-06 12:52:39Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2005 Nicklas Nordborg
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Johan Enell, Nicklas Nordborg, Martin Svensson

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.User"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="java.util.List"
	import="java.util.Set"
	import="java.util.TreeSet"
	import="java.util.HashSet"
	import="java.util.Arrays"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%
final SessionControl sc = Base.getExistingSessionControl(pageContext, true);
final String ID = sc.getId();
final float scale = Base.getScale(sc);
final String activePage = request.getParameter("page");
final DbControl dc = sc.newDbControl();
try
{
	final User user = User.getById(dc, sc.getLoggedInUserId());
	%>

	<base:page type="popup" title="<%="Reset list settings for "+HTML.encodeTags(user.getName())%>">
	<base:head>
		<script language="JavaScript">
		function resetFilters()
		{
			var frm = document.forms['preferences'];
			frm.submit();
		}
		</script>
	</base:head>
	<base:body>
	<p>

	<form action="submit_user.jsp?ID=<%=ID%>" method="post" name="preferences" 
		onsubmit="return false;">
	<input type=hidden name="cmd" value="ResetFilters">

	<h3 class="docked">Reset list settings for <%=HTML.encodeTags(user.getName())%> 
		<base:help helpid="userpreferences.resetfilters" /></h3>
	<div class="boxed">

		<table class="form" cellspacing=0>
		<tr>
			<td class="prompt">Which?</td>
			<td>
			<input type="checkbox" name="memory" value="1" checked disabled>In-memory<br>
			<input type="checkbox" name="database" value="1"><a 
				href="javascript:Forms.toggleCheckbox(document.forms['preferences'].database)"
				>In-database</a>
			</td>
		</tr>
		</table>
		<p>
		Use this functionality if you are experiencing problems when listing
		items on a list page. Try first with only the 'In-memory' option selected.
		If that doesn't help, try the 'In-database' option.
	</div>
		
	<p>
	<div align=center>
		<table align="center">
		<tr>
			<td width="50%"><base:button onclick="resetFilters();" title="Ok" /></td>
			<td width="50%"><base:button onclick="window.close();" title="Cancel" /></td>
		</tr>
		</table>
	</div>
	</form>
	</base:body>
	</base:page>
	<%
}
finally
{
	if (dc != null) dc.close();
}
%>
