<%-- $Id: list_bioassays.jsp 5130 2009-10-13 10:44:33Z nicklas $
	------------------------------------------------------------------
	Copyright (C) 2006 Jari Hkkinen, Nicklas Nordborg, Martin Svensson
	Copyright (C) 2007 Johan Enell

	This file is part of BASE - BioArray Software Environment.
	Available at http://base.thep.lu.se/

	BASE is free software; you can redistribute it and/or
	modify it under the terms of the GNU General Public License
	as published by the Free Software Foundation; either version 3
	of the License, or (at your option) any later version.

	BASE is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with BASE. If not, see <http://www.gnu.org/licenses/>.
	------------------------------------------------------------------

	@author Nicklas
	@version 2.0
--%>
<%@ page session="false"
	import="net.sf.basedb.core.SessionControl"
	import="net.sf.basedb.core.DbControl"
	import="net.sf.basedb.core.Item"
	import="net.sf.basedb.core.ItemContext"
	import="net.sf.basedb.core.Experiment"
	import="net.sf.basedb.core.BioAssaySet"
	import="net.sf.basedb.core.BioAssay"
	import="net.sf.basedb.core.RawBioAssay"
	import="net.sf.basedb.core.AnnotationSet"
	import="net.sf.basedb.core.AnnotationType"
	import="net.sf.basedb.core.Annotation"
	import="net.sf.basedb.core.ItemQuery"
	import="net.sf.basedb.core.ItemResultIterator"
	import="net.sf.basedb.core.ItemResultList"
	import="net.sf.basedb.core.Permission"
	import="net.sf.basedb.core.PluginDefinition"
	import="net.sf.basedb.core.PermissionDeniedException"
	import="net.sf.basedb.core.RawDataType"
	import="net.sf.basedb.core.Type"
	import="net.sf.basedb.core.Include"
	import="net.sf.basedb.core.query.Restrictions"
	import="net.sf.basedb.core.query.Expressions"
	import="net.sf.basedb.core.query.Orders"
	import="net.sf.basedb.core.query.Hql"
	import="net.sf.basedb.core.plugin.GuiContext"
	import="net.sf.basedb.core.plugin.Plugin"
	import="net.sf.basedb.core.snapshot.SnapshotManager"
	import="net.sf.basedb.util.Tree"
	import="net.sf.basedb.util.Enumeration"
	import="net.sf.basedb.util.BioAssaySetUtil"
	import="net.sf.basedb.clients.web.Base"
	import="net.sf.basedb.clients.web.ModeInfo"
	import="net.sf.basedb.clients.web.PermissionUtil"
	import="net.sf.basedb.clients.web.util.HTML"
	import="net.sf.basedb.util.Values"
	import="net.sf.basedb.util.formatter.Formatter"
	import="net.sf.basedb.clients.web.formatter.FormatterFactory"
	import="net.sf.basedb.clients.web.extensions.ExtensionsControl"
	import="net.sf.basedb.clients.web.extensions.JspContext"
	import="net.sf.basedb.clients.web.extensions.renderer.PrefixSuffixRenderer"
	import="net.sf.basedb.clients.web.extensions.toolbar.ToolbarUtil"
	import="net.sf.basedb.util.extensions.ExtensionsInvoker"
	import="java.util.List"
	import="java.util.LinkedList"
	import="java.util.Map"
	import="java.util.HashMap"
	import="java.util.Iterator"
	import="java.util.Collection"
%>
<%@ taglib prefix="base" uri="/WEB-INF/base.tld" %>
<%@ taglib prefix="tbl" uri="/WEB-INF/table.tld" %>
<%@ taglib prefix="t" uri="/WEB-INF/tab.tld" %>
<%@ taglib prefix="p" uri="/WEB-INF/path.tld" %>
<%@ taglib prefix="ext" uri="/WEB-INF/extensions.tld" %>
<%!
	private static final Item itemType = Item.BIOASSAY;
	private static final GuiContext guiContext = new GuiContext(itemType, GuiContext.Type.LIST);
%>
<%
final int bioAssaySetId = Values.getInt(request.getParameter("bioassayset_id"));
final SessionControl sc = Base.getExistingSessionControl(pageContext, Permission.DENIED, itemType);
final String ID = sc.getId();
final ItemContext cc = Base.getAndSetCurrentContext(sc, itemType, null, null);

final ModeInfo mode = ModeInfo.get(request.getParameter("mode"));
final String callback = request.getParameter("callback");
final String title = mode.generateTitle("bioassay", "bioassays");
final DbControl dc = sc.newDbControl();
ItemResultIterator<BioAssay> bioAssays = null;
ItemResultList<AnnotationType> annotationTypes = null;
ItemResultList<AnnotationType> experimentalFactors = null;
try
{
	final ItemQuery<AnnotationType> annotationTypeQuery = Base.getAnnotationTypesQuery(itemType);
	final BioAssaySet bioAssaySet = BioAssaySet.getById(dc, bioAssaySetId);
	final Experiment experiment = bioAssaySet.getExperiment();
	final boolean hasDbSpots = bioAssaySet.getNumSpots() > 0;
	final ItemQuery<AnnotationType> experimentalFactorQuery = experiment.getExperimentalFactors();
	experimentalFactorQuery.include(Include.MINE, Include.SHARED, Include.IN_PROJECT, Include.OTHERS);
	final int experimentId = experiment.getId();
	final RawDataType rawDataType = experiment.getRawDataType();
	final boolean createPermission = experiment.hasPermission(Permission.WRITE);
	final boolean deletePermission = createPermission;
	final boolean writePermission = createPermission;

	// Query for raw bioassays related to the current bioassay
	final ItemQuery<RawBioAssay> rawQuery = RawBioAssay.getQuery();
	rawQuery.include(Include.MINE, Include.SHARED, Include.IN_PROJECT, Include.OTHERS);
	rawQuery.join(Hql.innerJoin("bioAssays", "bas"));
	rawQuery.restrict(Restrictions.eq(Hql.alias("bas"), Expressions.parameter("bioAssay"))); 
	rawQuery.order(Orders.asc(Hql.property("name"))); 
	
	Map<Plugin.MainType, Integer> pluginCount = PluginDefinition.countPlugins(dc, guiContext);
	annotationTypes = annotationTypeQuery.list(dc);
	experimentalFactors = experimentalFactorQuery.list(dc);
	final SnapshotManager snapshotManager = new SnapshotManager();
	try
	{
		final ItemQuery<BioAssay> query = Base.getConfiguredQuery(dc, cc, true, bioAssaySet.getBioAssays(), mode);
		query.join(Hql.leftJoin("rawParents", "rba"));
		query.setDistinct(true);
		bioAssays = query.iterate(dc);
	}
	catch (Throwable t)
	{
		t.printStackTrace();
		cc.setMessage(t.getMessage());
	}
	int numListed = 0;
	JspContext jspContext = ExtensionsControl.createContext(dc, pageContext, 
			guiContext, bioAssaySet);
	ExtensionsInvoker invoker = ToolbarUtil.useExtensions(jspContext);
	ExtensionsInvoker overviewPlotInvoker = ExtensionsControl.useExtensions(jspContext, 
			"net.sf.basedb.clients.web.bioassayset.overviewplots");
	%>
	<base:page title="<%=title%>" type="<%=mode.getPageType()%>">
	<base:head scripts="table.js,tabcontrol.js" styles="table.css,headertabcontrol.css,path.css">
		<ext:scripts context="<%=jspContext%>" />
		<ext:stylesheets context="<%=jspContext%>" />
		<script language="JavaScript">
		var submitPage = 'index.jsp';
		var formId = 'bioAssaySets';
		function editItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', itemId, true);
		}
		function viewItem(itemId)
		{
			Main.viewOrEditItem('<%=ID%>', '<%=itemType.name()%>', itemId, false);
		}
		function itemOnClick(evt, itemId)
		{
			Table.itemOnClick(formId, evt, itemId, '<%=mode.getName()%>', viewItem, editItem, returnSelected);
		}
		function configureColumns()
		{
			Table.configureColumns('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>');
		}
		function runPlugin(cmd)
		{
			Table.submitToPopup(formId, cmd, 740, 540);
		}
		function returnSelected()
		{
			Table.returnSelected(formId, <%=callback != null ? "window.opener."+callback : "null" %>);
			window.close();
		}
		function presetOnChange()
		{
			Table.presetOnChange('<%=ID%>', formId, '<%=itemType.name()%>', '<%=(String)cc.getObject("defaultColumns")%>');
		}
		function switchTab(tabControlId, tabId)
		{
			if (tabId == 'properties' || tabId == 'overviewplots' || tabId == 'annotations')
			{
				location.href = '../bioassaysets/index.jsp?ID=<%=ID%>&cmd=ViewItem&experiment_id=<%=experiment.getId()%>&item_id=<%=bioAssaySetId%>&tab='+tabId;
			}
			else if (tabId == 'spotdata')
			{
				location.href = '../spotdata/index.jsp?ID=<%=ID%>&experiment_id=<%=experimentId%>&bioassayset_id=<%=bioAssaySetId%>';
			}
			else
			{
				TabControl.setActiveTab(tabControlId, tabId);
			}
		}
		function openPlotTool(bioAssayId)
		{
			Main.openPopup('../plotter/index.jsp?ID=<%=ID%>&bioassay_id='+bioAssayId, 'Plotter', 1000, 700);
		}
		function viewSpotData(bioAssayId)
		{
			location.href = '../spotdata/index.jsp?ID=<%=ID%>&bioassay_id='+bioAssayId;
		}
		</script>
	</base:head>
	
	<base:body>
		<p>
		<%
		if (!mode.isSelectionMode())
		{
			%>
			<p:path>
				<p:pathelement title="Experiments" href="<%="../index.jsp?ID="+ID%>" />
				<p:pathelement title="<%=HTML.encodeTags(experiment.getName())%>" 
					href="<%="../bioassaysets/index.jsp?ID="+ID+"&experiment_id="+experiment.getId()%>" />
				<p:pathelement title="<%=HTML.encodeTags(bioAssaySet.getName())%>" />
			</p:path>
			<%
		}
		%>

		<t:tabcontrol id="main" active="bioassays" switch="switchTab" notabs="<%=mode.isSelectionMode()%>">
		<t:tab id="properties" title="Properties" />
		
		<t:tab id="annotations" title="Annotations" 
				tooltip="View annotation values" />
		
		<t:tab id="bioassays" title="Bioassays">
		<%
		if (cc.getMessage() != null)
		{
			%>
			<div class="error"><%=cc.getMessage()%></div>
			<%
			cc.setMessage(null);
		}
		%>
		<tbl:table 
			id="bioAssaySets" 
			clazz="itemlist" 
			columns="<%=cc.getSetting("columns")%>"
			sortby="<%=cc.getSortProperty()%>" 
			direction="<%=cc.getSortDirection()%>"
			title="<%=title%>"
			action="index.jsp"
			sc="<%=sc%>"
			item="<%=itemType%>"
			>
			<tbl:hidden 
				name="mode" 
				value="<%=mode.getName()%>" 
			/>
			<tbl:hidden 
				name="bioassayset_id" 
				value="<%=String.valueOf(bioAssaySetId)%>" 
			/>
			<tbl:hidden 
				name="callback" 
				value="<%=callback%>" 
				skip="<%=callback == null%>" 
			/>
			<tbl:columndef 
				id="name"
				property="name"
				datatype="string"
				title="Name"
				sortable="true" 
				filterable="true"
				exportable="true"
				show="always" 
			/>
			<tbl:columndef 
				id="id"
				clazz="uniquecol"
				property="id"
				datatype="int"
				title="ID"
				sortable="true"
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="spots"
				property="numSpots"
				datatype="int"
				title="Spots in db"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef 
				id="fileSpots"
				property="numFileSpots"
				datatype="int"
				title="Spots in file"
				sortable="true" 
				filterable="true"
				exportable="true"
			/>
			<tbl:columndef
				id="rawBioAssays"
				title="Raw bioassays"
			/>
			<tbl:columndef 
				id="description"
				property="description"
				datatype="string"
				title="Description" 
				sortable="true" 
				filterable="true" 
				exportable="true"
			/>
			<tbl:columndef 
				id="tools"
				title="Tools" 
				show="<%=mode.isSelectionMode() ? "never" : "auto"%>"
			/>
			<%
			for (AnnotationType at : annotationTypes)
			{
				Enumeration<String, String> annotationEnum = null;
				Formatter formatter = FormatterFactory.getTypeFormatter(sc, at.getValueType());
				if (at.isEnumeration())
				{
					annotationEnum = new Enumeration<String, String>();
					List<?> values = at.getValues();
					for (Object value : values)
					{
						String encoded = formatter.format(value);
						annotationEnum.add(encoded, encoded);
					}
				}
				%>
				<tbl:columndef 
					id="<%="at"+at.getId()%>"
					title="<%=HTML.encodeTags(at.getName())+" [A]"%>" 
					property="<%="#"+at.getId()%>"
					annotation="true"
					datatype="<%=at.getValueType().getStringValue()%>"
					enumeration="<%=annotationEnum%>"
					sortable="false" 
					filterable="true" 
					exportable="true"
					formatter="<%=formatter%>"
					unit="<%=at.getDefaultUnit()%>"
				/>
				<%
			}
			%>
			<%
			for (AnnotationType at : experimentalFactors)
			{
				Enumeration<String, String> annotationEnum = null;
				Formatter formatter = FormatterFactory.getTypeFormatter(sc, at.getValueType());
				if (at.isEnumeration())
				{
					annotationEnum = new Enumeration<String, String>();
					List<?> values = at.getValues();
					for (Object value : values)
					{
						String encoded = formatter.format(value);
						annotationEnum.add(encoded, encoded);
					}
				}
				%>
				<tbl:columndef 
					id="<%="ef"+at.getId()%>"
					title="<%=HTML.encodeTags(at.getName())+" [EF]"%>" 
					property="<%="$rba.##"+at.getId()%>"
					exportproperty="<%="#" + at.getId() %>"
					annotation="true"
					datatype="<%=at.getValueType().getStringValue()%>"
					enumeration="<%=annotationEnum%>"
					sortable="false" 
					filterable="true" 
					exportable="true"
					formatter="<%=formatter%>"
				/>
				<%
			}
			%>
			<tbl:toolbar
				visible="<%=mode.hasToolbar()%>"
				>
				<tbl:button 
					image="columns.gif" 
					onclick="configureColumns()" 
					title="Columns&hellip;" 
					tooltip="Show, hide and re-order columns" 
				/>
				<tbl:button 
					image="import.gif" 
					onclick="runPlugin('ImportItems')" 
					title="Import&hellip;" 
					tooltip="Import data" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.IMPORT)%>"
				/>
				<tbl:button 
					image="export.gif" 
					onclick="runPlugin('ExportItems')" 
					title="Export&hellip;" 
					tooltip="Export data" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.EXPORT)%>"
				/>
				<tbl:button
					disabled="<%=!createPermission%>"
					image="<%=createPermission ? "filter.gif" : "filter_disabled.gif"%>"
					onclick="<%="runPlugin('NewFilteredBioAssaySet')"%>"
					title="Filter bioassay set&hellip;"
					tooltip="<%=createPermission ? 
						"Create a new bioassay set by filtering this bioassayset" :
						"You do not have permission analyze this experiment"%>"
					visible="<%=!mode.isSelectionMode()%>"
	 			/>
				<tbl:button 
					image="runplugin.gif" 
					onclick="runPlugin('RunListPlugin')" 
					title="Run plugin&hellip;" 
					tooltip="Run a plugin" 
					visible="<%=pluginCount.containsKey(Plugin.MainType.OTHER) && !mode.isSelectionMode()%>"
				/>
				<tbl:button 
					disabled="<%=!createPermission%>"
					image="<%=createPermission ? "runplugin.gif" : "runplugin_disabled.gif"%>" 
					onclick="<%="runPlugin('RunListAnalysisPlugin')"%>"
					title="Run analysis&hellip;" 
					tooltip="<%=createPermission ? "Run an analysis plugin" : 
						"You do not have permission to analyze this experiment"%>"
					visible="<%=pluginCount.containsKey(Plugin.MainType.ANALYZE) && !mode.isSelectionMode()%>"
				/>
				<ext:render extensions="<%=invoker%>" context="<%=jspContext%>" 
					wrapper="<%=new PrefixSuffixRenderer(jspContext, "<td>", "</td>") %>"/>
			</tbl:toolbar>
			<tbl:navigator
				page="<%=cc.getPage()%>" 
				rowsperpage="<%=cc.getRowsPerPage()%>" 
				totalrows="<%=bioAssays == null ? 0 : bioAssays.getTotalCount()%>" 
				visible="<%=mode.hasNavigator()%>"
			/>
			<tbl:data>
				<tbl:columns>
				<tbl:presetselector 
					clazz="columnheader"
					colspan="3"
					onchange="presetOnChange()"
				/>
				</tbl:columns>
				<tr>
					<tbl:header 
						clazz="index"
						>&nbsp;</tbl:header>
					<tbl:header 
						clazz="check" 
						visible="<%=mode.hasCheck()%>"
						><base:icon 
							image="check_uncheck.gif" 
							tooltip="Check/uncheck all" 
							onclick="Forms.checkUncheck(document.forms[formId])" style="align: left;"
						/></tbl:header>
					<tbl:header 
						clazz="check" 
						visible="<%=mode.hasRadio()%>"
						/>
					<tbl:header 
						clazz="icons" 
						visible="<%=mode.hasIcons()%>"
						>&nbsp;</tbl:header>
					<tbl:propertyfilter />
				</tr>
		
					<tbl:rows>
					<%
					int index = cc.getPage()*cc.getRowsPerPage();
					int selectedItemId = cc.getId();
					if (bioAssays != null)
					{						
						while (bioAssays.hasNext())
						{
							BioAssay item = bioAssays.next();
							boolean bioAssayHasDbSpots = item.getNumSpots() > 0;
							int itemId = item.getId();
							String name = HTML.encodeTags(item.getName());
							String tooltip = mode.isSelectionMode() ?
									"Select this item" : "View this item" + (writePermission ? " (use CTRL, ALT or SHIFT to edit)" : "");
							index++;
							numListed++;					
							%>
							<tbl:row>
								<tbl:header 
									clazz="index"
									><%=index%></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasCheck()%>"
									><input 
											type="checkbox" 
											name="<%=itemId%>" 
											value="<%=itemId%>" 
											title="<%=name%>" 
											<%=cc.getSelected().contains(itemId) ? "checked" : ""%>
										></tbl:header>
								<tbl:header 
									clazz="check" 
									visible="<%=mode.hasRadio()%>"
									><input 
											type="radio" 
											name="item_id" 
											value="<%=itemId%>" 
											title="<%=name%>" 
											<%=selectedItemId == itemId ? "checked" : ""%>
										></tbl:header>
								<tbl:header 
									clazz="icons" 
									visible="<%=mode.hasIcons()%>"
									>&nbsp;</tbl:header>
								<tbl:cell column="name"><div class="link" 
									onclick="itemOnClick(<%=writePermission ? "event" : null%>, <%=itemId%>)" 
									title="<%=tooltip%>"><%=name%></div></tbl:cell>
								<tbl:cell column="id"><%=item.getId()%></tbl:cell>
								<tbl:cell column="spots"><%=item.getNumSpots()%></tbl:cell>
								<tbl:cell column="fileSpots"><%=item.getNumFileSpots()%></tbl:cell>
								<tbl:cell column="description"><%=HTML.encodeTags(item.getDescription())%></tbl:cell>
								<tbl:cell column="rawBioAssays">
									<%
									rawQuery.setParameter("bioAssay", itemId, Type.INT);
									try
									{
										String separator = "";
										for (RawBioAssay rba : rawQuery.list(dc))
										{
											out.write(separator);
											if (mode.hasPropertyLink())
											{
												out.write(Base.getLinkedName(ID, rba, false, mode.hasEditLink()));
											}
											else
											{
												out.write(HTML.encodeTags(rba.getName()));
											}
											separator = ", ";
										}
									}
									catch (Throwable t)
									{
										%>
										<div class="error"><%=t.getMessage()%></div>
										<%
									}
									%>
								</tbl:cell>
								<%
								AnnotationSet as = item.isAnnotated() ? item.getAnnotationSet() : null;
								if (as != null)
								{
									for (AnnotationType at : annotationTypes)
									{
										if (as.hasAnnotation(at))
										{
											Annotation a = as.getAnnotation(at);
											String suffix = a.getUnitSymbol(null);
											if (suffix != null) suffix = "&nbsp;" + suffix;
											%>
											<tbl:cell 
												column="<%="at"+at.getId()%>"
												><tbl:cellvalue 
													list="<%=a.getValues(null)%>"
													suffix="<%=suffix%>"
											/></tbl:cell>
											<%
										}
									}
								}
								for (AnnotationType at : experimentalFactors)
								{
									%>
									<tbl:cell column="<%="ef"+at.getId()%>"
										><tbl:cellvalue
										list="<%=BioAssaySetUtil.getAnnotationValues(dc, snapshotManager, item, at)%>"
									/></tbl:cell>
									<%
								}								
								%>
								<tbl:cell column="tools">
									<nobr>
									<% 
									if (bioAssayHasDbSpots) 
									{
										%>
										<a href="javascript:openPlotTool(<%=itemId%>)" 
											title="A simple plot tool"><img 
											src="../../../images/plotter.gif" border="0"></a>
										<a href="javascript:viewSpotData(<%=itemId%>)"
											title="View spot data as a table"><img 
											src="../../../images/table.gif" border="0"></a>
										<%
									}
									%>
									</nobr>
								</tbl:cell>
							</tbl:row>
							<%
						}
					}
					%>
					</tbl:rows>
				</tbl:data>
			<%
			if (numListed == 0)
			{
				%>
				<tbl:panel><%=bioAssays == null || bioAssays.getTotalCount() == 0 ? "No bioassays were found" : "No bioassays on this page. Please select another page!" %></tbl:panel>
				<%
			}
			else
			{
				%>
				<tbl:navigator
					page="<%=cc.getPage()%>" 
					rowsperpage="<%=cc.getRowsPerPage()%>" 
					totalrows="<%=bioAssays == null ? 0 : bioAssays.getTotalCount()%>" 
					visible="<%=mode.hasNavigator()%>"
					locked="true"
				/>
				<%
			}
			%>

		</tbl:table>
		<base:buttongroup align="center" clazz="fixedatbottom">
			<base:button onclick="returnSelected();" title="Ok" visible="<%=mode.hasOkButton()%>" />
			<base:button onclick="window.close();" title="Cancel" visible="<%=mode.hasCancelButton()%>" />
			<base:button onclick="window.close();" title="Close" visible="<%=mode.hasCloseButton()%>" />
		</base:buttongroup>
		</t:tab>
		
		<t:tab id="spotdata" title="Spot data" visible="<%=hasDbSpots%>" />
		
		<t:tab id="overviewplots" title="Overview plots" 
			visible="<%=overviewPlotInvoker.getNumExtensions() > 0%>" />
		
		</t:tabcontrol>

	</base:body>
	</base:page>
	<%
}
finally
{
	if (bioAssays != null) bioAssays.close();
	if (dc != null) dc.close();
}
%>
